public class CyclicBarrier {

    private int arrived = 0;
    private int N;
    
    public CyclicBarrier(int N) {
	this.N = N;
    }
  
    public synchronized void await()
	throws InterruptedException {
	arrived++;
	if (arrived < N)
	    wait();
	else { 
	    notifyAll();
	    arrived = 0;
	}
    }
}
